// CmdMgrDefs.cpp
//

#include "stdafx.h"

/////////////////////////////////////////////////////////
// Argument structures
/////////////////////////////////////////////////////////

Arg _helpArgs[] = 
{
	{"[<Command>]", "<Command>: Help for specified command."},
	{"[-dN]",       "-d: Print Details (-d0=None, -d1=Comments, -d2=All)"},
};

Arg _findArgs[] = 
{
	{"[-n]",  "-n: Print Names"},
	{"[-tN]", "-t: Timeout in milliseconds (ie. -t1000 = 1 second timeout)"}
};

Arg _IpTimeoutArgs[] =
{
	{"<IP>", "<IP>: IP Address of device"},
	{"[-tN]", "-t: Timeout in milliseconds (ie. -t1000 = 1 second timeout)"}
};

Arg _promptArgs[] =
{
	{"<string>", "<string>: New prompt"},
};

Arg _devInfoArgs[] =
{
	{"<Port>", "<Port>: Port Number. (1 <= Port <= 256)"}
};

Arg _logStateArgs[] =
{
	{"<Log State>", "<Log State>: 0=Off, 1=On"}
};

Arg _addServiceArgs[] =
{
	{"<Port>", "<Port>: Port Number. (1 <= Port <= 256)"},
	{"<IP>", "<IP>: IP Address of device"},
	{"<Tcp Port>", "<Tcp Port>: Tcp Port number to use"}
};

Arg _remServiceArgs[] =
{
	{"<Port>", "<Port>: Port Number. (1 <= Port <= 256)"},
	{"<Service #>", "<Service #>: The service number from 1 to 8"}
};

Arg _setServiceArgs[] =
{
	{"<Port>", "<Port>: Port Number. (1 <= Port <= 256)"},
	{"<Service #>", "<Service #>: The service number from 1 to 8"},
	{"<IP>", "<IP>: IP Address of device"},
	{"<Tcp Port>", "<Tcp Port>: Tcp Port number to use"}
};

Arg _nameArgs[] =
{
	{"<IP>", "<IP>: IP Address of device"},
	{"[-d<\"device name>\"]", "-d<device name>: Name of device (use \" to preserve spaces)"},
	{"[-1<\"port 1 name>\"]", "-d<port 1 name>: Name of TCP port 1 (ie. -1\"Port 1 Name\")"},
	{"[-2<\"port 2 name>\"]", "-d<port 2 name>: Name of TCP port 2 (if 2 port device)"},
	{"[-tN]", "-t: Timeout in milliseconds (ie. -t1000 = 1 second timeout)"}
};

Arg _portInfoArgs[] =
{
	{"<Port>", "<Port>: Port Number. (1 <= Port <= 256)"},
	{"[-aN]", "-a: Timeout Reconnect. (No = -a0, Yes = -a1)"},
	{"[-sN]", "-s: Server Reconnect. (No = -s0, Yes = -s1)"},
	{"[-rN]", "-r: Reconnect attempts. (forever = -r0)"},
	{"[-cN]", "-c: Connection timeout in seconds. (ie. -c6 = 6 seconds)"},
	{"[-dN]", "-d: DTR Connection."
				"@    0 = Tie DTR to DCD, DSR kept active"
				"@    1 = Tie DTR to DCD, DSR kept inactive"
				"@    2 = Tie DTR to DSR, DCD kept active"
				"@    3 = Tie DTR to DSR, DCD kept inactive"
				"@    4 = Tie DTR to DSR and DCD, DSR kept active"
				"@    5 = Do not tie DTR to any other signal"},
	{"[-uN]", "-u: Use RFC2217. (No = -u0, Yes = -u1)"},
	{"[-tN]", "-t: Transmit Empty. (0 = CPR, 1 = Device Server)"},
	{"[-bN]", "-b: Buffer Writes. (No = -b0, Yes = -b1)"},
	{"[-kN]", "-k: TCP KeepAlive. (No = -k0, Yes = -k1)"},
	{"[-mN]", "-m: KeepAlive Time (msec)"},
	{"[-iN]", "-i: KeepAlive Interval (msec)"},
	{"[-LN]", "-L: Listen Mode. (None = -L0, Normal = -L1, Auto = -L2"},
	{"[-pN]", "-p: Listen Mode TCP Port"}
};

Arg _defPortInfoArgs[] =
{
	{"[-aN]", "-a: Timeout Reconnect. (No = -a0, Yes = -a1)"},
	{"[-sN]", "-s: Server Reconnect. (No = -s0, Yes = -s1)"},
	{"[-rN]", "-r: Reconnect attempts. (forever = -r0)"},
	{"[-cN]", "-c: Connection timeout in seconds. (ie. -c6 = 6 seconds)"},
	{"[-dN]", "-d: DTR Connection."
				"@    0 = Tie DTR to DCD, DSR kept active"
				"@    1 = Tie DTR to DCD, DSR kept inactive"
				"@    2 = Tie DTR to DSR, DCD kept active"
				"@    3 = Tie DTR to DSR, DCD kept inactive"
				"@    4 = Tie DTR to DSR and DCD, DSR kept active"
				"@    5 = Do not tie DTR to any other signal"},
	{"[-uN]", "-u: Use RFC2217. (No = -u0, Yes = -u1)"},
	{"[-tN]", "-t: Transmit Empty. (0 = CPR, 1 = Device Server)"},
	{"[-bN]", "-b: Buffer Writes. (No = -b0, Yes = -b1)"},
	{"[-kN]", "-k: TCP KeepAlive. (No = -k0, Yes = -k1)"},
	{"[-mN]", "-m: KeepAlive Time (msec)"},
	{"[-iN]", "-i: KeepAlive Interval (msec)"},
	{"[-LN]", "-L: Listen Mode. (None = -L0, Normal = -L1, Auto = -L2"},
	{"[-pN]", "-p: Listen Mode TCP Port"}
};

Arg _cpcExportArgs[] =
{
	{"<File>", "<File>: Com Port Config File Name"}
};

Arg _cpcImportArgs[] =
{
	{"<File>", "<File>: Com Port Config File Name"},
	{"[-s]",  "-s: Do not print returned PortInfo structures"},
	{"[-a]",  "-a: Add ports to system"},
	{"[-n]",  "-n: No prompt"}
};

Arg _removeAllArgs[] =
{
	{"[-s]",  "-s: Do not print results"},
	{"[-n]",  "-n: No prompt"}
};

Arg _loopbackArgs[] =
{
	{"[-cN-N,N]", "-c: Com ports to test.(List. N-N is range. Defaults to all)"},
	{"[-tN]",     "-t: Number of threads. (Defaults to 1)"},
	{"[-eN]",     "-e: Print errors. (No(default) = -e0, Yes = -e1)"},
	{"[-r]",      "-r: Randomly assign Com Ports to threads."},
	{"[-dN]",     "-s: Size of data packet. (Defaults to 100)"},
	{"[-nN]",     "-d: Number of data runs per open. (Defaults to 1)"},
	{"[-pN]",     "-p: Print interval in seconds. (Defaults to 10 seconds)"},
	{"[-xN]",     "-x: Number of times to test. (Defaults to 0=forever)"},
	{"[-v]",      "-v: Verbose output."},
};

/////////////////////////////////////////////////////////
// CommandArgs structures
/////////////////////////////////////////////////////////

CommandArgs helpArgs        = {2, _helpArgs};
CommandArgs findArgs        = {2, _findArgs};
CommandArgs IpTimeoutArgs   = {2, _IpTimeoutArgs};
CommandArgs promptArgs      = {1, _promptArgs};
CommandArgs devInfoArgs     = {1, _devInfoArgs};
CommandArgs nameArgs        = {5, _nameArgs};
CommandArgs portInfoArgs    = {14, _portInfoArgs};
CommandArgs defPortInfoArgs = {13, _defPortInfoArgs};
CommandArgs addServiceArgs  = {3, _addServiceArgs};
CommandArgs remServiceArgs  = {2, _remServiceArgs};
CommandArgs setServiceArgs  = {4, _setServiceArgs};
CommandArgs cpcExportArgs   = {1, _cpcExportArgs};
CommandArgs cpcImportArgs   = {4, _cpcImportArgs};
CommandArgs removeAllArgs   = {2, _removeAllArgs};
CommandArgs loopbackArgs    = {9, _loopbackArgs};
CommandArgs logStateArgs    = {1, _logStateArgs};


/////////////////////////////////////////////////////////
// Commands
/////////////////////////////////////////////////////////

CommandItem Commands[NumCmds] = 
{
	{"",            0,  CmdUnknownCommand, NULL,            ""},
	{"?",           1,  CmdHelp,           NULL,            "print help to screen. No need to press the return key."},
	{"/",           1,  CmdHelp,           NULL,            "print help to screen. No need to press the return key."},
	{"help",        1,  CmdHelp,           &helpArgs,       "print help to screen."},
	{"addport",     4,  CmdAddPort,        &devInfoArgs,    "Add a CPR port to the system using default values."},
	{"addservice",  4,  CmdAddService,     &addServiceArgs, "Add a new service to a CPR port."},
	{"default",     3,  CmdGetDefault,     NULL,            "Get the default port info."},
	{"devinfo",     3,  CmdPortDevice,     &devInfoArgs,    "Display the Device Info for the specified port."},
	{"exportcpc",   1,  CmdExportCPC,      &cpcExportArgs,  "Export port definitions to a Com Port Config file."},
	{"find",        1,  CmdFindDevices,    &findArgs,       "Find devices on the network."},
	{"getlogstate", 4,  CmdGetLogState,    NULL,			   "Get logging state of CprIf.dll."},
	{"getnames",    4,  CmdGetDeviceNames, &IpTimeoutArgs,  "Get device and port names for a device."},
	{"importcpc",   1,  CmdImportCPC,      &cpcImportArgs,  "Import port definitions from a Com Port Config file."},
	{"loopback",    1,  CmdLoopback,       &loopbackArgs,   "Loopback test. A loopback adapter is required."},
	{"numports",    2,  CmdNumPorts,       NULL,            "Display the number of CPR ports configured on this system."},
	{"portinfo",    5,  CmdPortInfo,       &devInfoArgs,    "Display the Port Info for the specified port."},
	{"portmap",     5,  CmdPortMap,        NULL,            "Display the CPR Port Map."},
	{"portstatus",  5,  CmdPortStatus,     &devInfoArgs,    "Display the Port Status for the specified port."},
	{"portusage",   5,  CmdPortUsage,      NULL,            "Display Port Usage Array."},
	{"prompt",      2,  CmdPrompt,         &promptArgs,     "Change the prompt."},
	{"query",       3,  CmdQuery,          &IpTimeoutArgs,  "Query information for one device."},
	{"quit",        3,  CmdQuit,           NULL,            "quit program (or Ctrl-C)."},
	{"reach",       3,  CmdIsReachable,    &IpTimeoutArgs,  "Discover if device is reachable."},
	{"reachex",     3,  CmdIsReachableEx,  &IpTimeoutArgs,  "Discover if device is reachable, send only one packet."},
	{"remall",      4,  CmdRemoveAllPorts, &removeAllArgs,  "Remove all CPR ports from the system."},
	{"remport",     4,  CmdRemovePort,     &devInfoArgs,    "Remove a CPR port from the system."},
	{"remservice",  4,  CmdRemoveService,  &remServiceArgs, "Remove a service from a CPR port."},
	{"setdefinfo",  4,  CmdSetDefPortInfo, &defPortInfoArgs,"Set default information used when creating ports."},
	{"setinfo",     4,  CmdSetPortInfo,    &portInfoArgs,   "Set information on a port."},
	{"setlogstate", 4,  CmdSetLogState,    &logStateArgs,   "Set logging state of CprIf.dll."},
	{"setnames",    4,  CmdSetDeviceNames, &nameArgs,       "Set device and port names for a device."},
	{"setservice",  4,  CmdSetService,     &setServiceArgs, "Set (Modify) an existing service of a CPR port."},
	{"ver",         1,  CmdGetVersions,    NULL,            "Get CPR Driver and CPR Interface DLL versions."}
};

CommandItem HiddenCommands[1] = 
{
	{"releaseport", 11, CmdReleasePort,    NULL,            ""},
};
